//
// Copyright (c) Microsoft Corporation.  All rights reserved.
//
//
// Use of this source code is subject to the terms of the Microsoft end-user
// license agreement (EULA) under which you licensed this SOFTWARE PRODUCT.
// If you did not accept the terms of the EULA, you are not authorized to use
// this source code. For a copy of the EULA, please see the LICENSE.RTF on your
// install media.
//
//------------------------------------------------------------------------------
//
//  Copyright (C) 2007-2009, Freescale Semiconductor, Inc. All Rights Reserved.
//  THIS SOURCE CODE, AND ITS USE AND DISTRIBUTION, IS SUBJECT TO THE TERMS
//  AND CONDITIONS OF THE APPLICABLE LICENSE AGREEMENT
//
//------------------------------------------------------------------------------
//
//  File:  NANDtypes.h
//
//  Contains definitions for FMD impletation of NAND flash memory device.
//
//------------------------------------------------------------------------------
#ifndef __NAND_TYPES_H__
#define __NAND_TYPES_H__

NandChipInfo ChipInfo[] = 
{
	//K9G8G08U0M
    {
        {NAND, 4152, 8192 * 128, 128, 8192},        //FlashInfo   fi; 
        {0xEC, 0xD7, 0x14, 0x76},                   //BYTE        NANDCode[NANDID_LENGTH]
        3,                                          //BYTE        NumBlockCycles
        5,                                          //BYTE        ChipAddrCycleNum
        8,                                          //BYTE        DataWidth
        1,                                          //BYTE        BBMarkNum
        {0},                                        //BYTE        BBMarkPage
        6,                                          //BYTE        StatusBusyBit
        0,                                          //BYTE        StatusErrorBit
        448,                                        //WORD        SpareDataLength
        0x70,                                       //BYTE        CmdReadStatus
        0x00,                                       //BYTE        CmdRead1
        0x30,                                       //BYTE        CmdRead2
        0x90,                                       //BYTE        CmdReadId
        0xff,                                       //BYTE        CmdReset
        0x80,                                       //BYTE        CmdWrite1
        0x10,                                       //BYTE        CmdWrite2
        0x60,                                       //BYTE        CmdErase1
        0xD0,                                       //BYTE        CmdErase2
        {25, 16, 25, 20}                            //NANDTiming  timings
    },
	//MT29F64G08
    {
        {NAND, 4096, 8192 * 256, 256, 8192},        //FlashInfo   fi; 
        {0x2C, 0x88, 0x04, 0x4b},                   //BYTE        NANDCode[NANDID_LENGTH]
        3,                                          //BYTE        NumBlockCycles
        5,                                          //BYTE        ChipAddrCycleNum
        8,                                          //BYTE        DataWidth
        1,                                          //BYTE        BBMarkNum
        {0},                                        //BYTE        BBMarkPage
        6,                                          //BYTE        StatusBusyBit
        0,                                          //BYTE        StatusErrorBit
        448,                                        //WORD        SpareDataLength
        0x70,                                       //BYTE        CmdReadStatus
        0x00,                                       //BYTE        CmdRead1
        0x30,                                       //BYTE        CmdRead2
        0x90,                                       //BYTE        CmdReadId
        0xff,                                       //BYTE        CmdReset
        0x80,                                       //BYTE        CmdWrite1
        0x10,                                       //BYTE        CmdWrite2
        0x60,                                       //BYTE        CmdErase1
        0xD0,                                       //BYTE        CmdErase2
        {25, 16, 25, 20}                            //NANDTiming  timings
    },
	//Samsung K9F4G08	512MB	-> Tested	
    {
        {NAND, 4096, 2048 * 64, 64, 2048},        //FlashInfo   fi; 
        {0xEC, 0xDC, 0x10, 0x95},                   //BYTE        NANDCode[NANDID_LENGTH]
        3,                                          //BYTE        NumBlockCycles
        5,                                          //BYTE        ChipAddrCycleNum
        8,                                          //BYTE        DataWidth
        1,                                          //BYTE        BBMarkNum
        {0},                                        //BYTE        BBMarkPage
        6,                                          //BYTE        StatusBusyBit
        0,                                          //BYTE        StatusErrorBit
        64,                                         //WORD        SpareDataLength
        0x70,                                       //BYTE        CmdReadStatus
        0x00,                                       //BYTE        CmdRead1
        0x30,                                       //BYTE        CmdRead2
        0x90,                                       //BYTE        CmdReadId
        0xff,                                       //BYTE        CmdReset
        0x80,                                       //BYTE        CmdWrite1
        0x10,                                       //BYTE        CmdWrite2
        0x60,                                       //BYTE        CmdErase1
        0xD0,                                       //BYTE        CmdErase2
        {12, 5, 12, 20}                            //NANDTiming  timings
    },
	//K9K4G08	-> Not tested
    {
        {NAND, 4096, 2048 * 64, 64, 2048},        //FlashInfo   fi; 
        {0xEC, 0xDC, 0xC1, 0x15},                   //BYTE        NANDCode[NANDID_LENGTH]
        3,                                          //BYTE        NumBlockCycles
        5,                                          //BYTE        ChipAddrCycleNum
        8,                                          //BYTE        DataWidth
        1,                                          //BYTE        BBMarkNum
        {0},                                        //BYTE        BBMarkPage
        6,                                          //BYTE        StatusBusyBit
        0,                                          //BYTE        StatusErrorBit
        64,                                         //WORD        SpareDataLength
        0x70,                                       //BYTE        CmdReadStatus
        0x00,                                       //BYTE        CmdRead1
        0x30,                                       //BYTE        CmdRead2
        0x90,                                       //BYTE        CmdReadId
        0xff,                                       //BYTE        CmdReset
        0x80,                                       //BYTE        CmdWrite1
        0x10,                                       //BYTE        CmdWrite2
        0x60,                                       //BYTE        CmdErase1
        0xD0,                                       //BYTE        CmdErase2
        {20, 10, 25, 20}                            //NANDTiming  timings
    },
	//ST04GW		-> Not tested. Tested on old modules
    {
        {NAND, 4096, 2048 * 64, 64, 2048},        //FlashInfo   fi; 
        {0x20, 0xDC, 0x80, 0x95},                   //BYTE        NANDCode[NANDID_LENGTH]
        3,                                          //BYTE        NumBlockCycles
        5,                                          //BYTE        ChipAddrCycleNum
        8,                                          //BYTE        DataWidth
        1,                                          //BYTE        BBMarkNum
        {0},                                        //BYTE        BBMarkPage
        6,                                          //BYTE        StatusBusyBit
        0,                                          //BYTE        StatusErrorBit
        64,                                         //WORD        SpareDataLength
        0x70,                                       //BYTE        CmdReadStatus
        0x00,                                       //BYTE        CmdRead1
        0x30,                                       //BYTE        CmdRead2
        0x90,                                       //BYTE        CmdReadId
        0xff,                                       //BYTE        CmdReset
        0x80,                                       //BYTE        CmdWrite1
        0x10,                                       //BYTE        CmdWrite2
        0x60,                                       //BYTE        CmdErase1
        0xD0,                                       //BYTE        CmdErase2
        {15, 5, 15, 20}                             //NANDTiming  timings
    },
	//HY27UF084G		-> Not tested.
    {
        {NAND, 4096, 2048 * 64, 64, 2048},        //FlashInfo   fi; 
        {0xAD, 0xDC, 0x80, 0x95},                   //BYTE        NANDCode[NANDID_LENGTH]
        3,                                          //BYTE        NumBlockCycles
        5,                                          //BYTE        ChipAddrCycleNum
        8,                                          //BYTE        DataWidth
        1,                                          //BYTE        BBMarkNum
        {0},                                        //BYTE        BBMarkPage
        6,                                          //BYTE        StatusBusyBit
        0,                                          //BYTE        StatusErrorBit
        64,                                         //WORD        SpareDataLength
        0x70,                                       //BYTE        CmdReadStatus
        0x00,                                       //BYTE        CmdRead1
        0x30,                                       //BYTE        CmdRead2
        0x90,                                       //BYTE        CmdReadId
        0xff,                                       //BYTE        CmdReset
        0x80,                                       //BYTE        CmdWrite1
        0x10,                                       //BYTE        CmdWrite2
        0x60,                                       //BYTE        CmdErase1
        0xD0,                                       //BYTE        CmdErase2
        {15, 5, 15, 20}                            //NANDTiming  timings
    },
    //MT29F16G08
    {
        {NAND, 4096, 4096 * 128, 128, 4096},        //FlashInfo   fi; 
        {0x2C, 0xD5, 0x94, 0x3e},                   //BYTE        NANDCode[NANDID_LENGTH]
        3,                                          //BYTE        NumBlockCycles
        5,                                          //BYTE        ChipAddrCycleNum
        8,                                          //BYTE        DataWidth
        1,                                          //BYTE        BBMarkNum
        {0},                                        //BYTE        BBMarkPage
        6,                                          //BYTE        StatusBusyBit
        0,                                          //BYTE        StatusErrorBit
        218,                                        //WORD        SpareDataLength
        0x70,                                       //BYTE        CmdReadStatus
        0x00,                                       //BYTE        CmdRead1
        0x30,                                       //BYTE        CmdRead2
        0x90,                                       //BYTE        CmdReadId
        0xff,                                       //BYTE        CmdReset
        0x80,                                       //BYTE        CmdWrite1
        0x10,                                       //BYTE        CmdWrite2
        0x60,                                       //BYTE        CmdErase1
        0xD0,                                       //BYTE        CmdErase2
        {25, 16, 25, 20}                            //NANDTiming  timings
    },
    //MT29F16G08CBACA
    {
        {NAND, 2048, 4096 * 256, 256, 4096},        //FlashInfo   fi; 
        {0x2C, 0x48, 0x04, 0x4A},                   //BYTE        NANDCode[NANDID_LENGTH]
        3,                                          //BYTE        NumBlockCycles
        5,                                          //BYTE        ChipAddrCycleNum
        8,                                          //BYTE        DataWidth
        1,                                          //BYTE        BBMarkNum
        {0},                                        //BYTE        BBMarkPage
        6,                                          //BYTE        StatusBusyBit
        0,                                          //BYTE        StatusErrorBit
        224,                                        //WORD        SpareDataLength
        0x70,                                       //BYTE        CmdReadStatus
        0x00,                                       //BYTE        CmdRead1
        0x30,                                       //BYTE        CmdRead2
        0x90,                                       //BYTE        CmdReadId
        0xff,                                       //BYTE        CmdReset
        0x80,                                       //BYTE        CmdWrite1
        0x10,                                       //BYTE        CmdWrite2
        0x60,                                       //BYTE        CmdErase1
        0xD0,                                       //BYTE        CmdErase2
        {25, 16, 25, 20}                            //NANDTiming  timings
    },
    //MT29F8G08
    {
        {NAND, 4096, 2048 * 128, 128, 2048},        //FlashInfo   fi;     
        {0x2C, 0xD3, 0x94, 0x2d},                   //BYTE        NANDCode[NANDID_LENGTH]
        3,                                          //BYTE        NumBlockCycles
        5,                                          //BYTE        ChipAddrCycleNum
        8,                                          //BYTE        DataWidth
        1,                                          //BYTE        BBMarkNum
        {0},                                        //BYTE        BBMarkPage
        6,                                          //BYTE        StatusBusyBit
        0,                                          //BYTE        StatusErrorBit
        64,                                        //WORD        SpareDataLength
        0x70,                                       //BYTE        CmdReadStatus
        0x00,                                       //BYTE        CmdRead1
        0x30,                                       //BYTE        CmdRead2
        0x90,                                       //BYTE        CmdReadId
        0xff,                                       //BYTE        CmdReset
        0x80,                                       //BYTE        CmdWrite1
        0x10,                                       //BYTE        CmdWrite2
        0x60,                                       //BYTE        CmdErase1
        0xD0,                                       //BYTE        CmdErase2
        {25, 16, 25, 20}                             //NANDTiming  timings
    },
    //MT29F16G08DAA
    {
        {NAND, 4096, 4096 * 64, 64, 4096},        //FlashInfo   fi;     
        {0x2C, 0xD3, 0x90, 0x2e},                   //BYTE        NANDCode[NANDID_LENGTH]
        3,                                          //BYTE        NumBlockCycles
        5,                                          //BYTE        ChipAddrCycleNum
        8,                                          //BYTE        DataWidth
        1,                                          //BYTE        BBMarkNum
        {0},                                        //BYTE        BBMarkPage
        6,                                          //BYTE        StatusBusyBit
        0,                                          //BYTE        StatusErrorBit
        218,                                        //WORD        SpareDataLength
        0x70,                                       //BYTE        CmdReadStatus
        0x00,                                       //BYTE        CmdRead1
        0x30,                                       //BYTE        CmdRead2
        0x90,                                       //BYTE        CmdReadId
        0xff,                                       //BYTE        CmdReset
        0x80,                                       //BYTE        CmdWrite1
        0x10,                                       //BYTE        CmdWrite2
        0x60,                                       //BYTE        CmdErase1
        0xD0,                                       //BYTE        CmdErase2
        {11, 8, 15, 20}                             //NANDTiming  timings
    },
    //K9LBG08U0D
    {
        {NAND, 8192, 4096 * 128, 128, 4096},        //FlashInfo   fi;     
        {0xEC, 0xD7, 0xD5, 0x29},                   //BYTE        NANDCode[NANDID_LENGTH]
        3,                                          //BYTE        NumBlockCycles
        5,                                          //BYTE        ChipAddrCycleNum
        8,                                          //BYTE        DataWidth
        1,                                          //BYTE        BBMarkNum
        {127},                                      //BYTE        BBMarkPage
        6,                                          //BYTE        StatusBusyBit
        0,                                          //BYTE        StatusErrorBit
        218,                                        //WORD        SpareDataLength
        0x70,                                       //BYTE        CmdReadStatus
        0x00,                                       //BYTE        CmdRead1
        0x30,                                       //BYTE        CmdRead2
        0x90,                                       //BYTE        CmdReadId
        0xff,                                       //BYTE        CmdReset
        0x80,                                       //BYTE        CmdWrite1
        0x10,                                       //BYTE        CmdWrite2
        0x60,                                       //BYTE        CmdErase1
        0xD0,                                       //BYTE        CmdErase2
        {20, 8, 15, 20}                             //NANDTiming  timings
    },
    
    //H27UBG8T2A
    {
        {NAND, 2048, 8192 * 256, 256, 8192},        //FlashInfo   fi;     
        {0xAD, 0xD7, 0x94, 0x9a},                   //BYTE        NANDCode[NANDID_LENGTH]
        3,                                          //BYTE        NumBlockCycles
        5,                                          //BYTE        ChipAddrCycleNum
        8,                                          //BYTE        DataWidth
        2,                                          //BYTE        BBMarkNum
        {0, 255},                                   //BYTE        BBMarkPage
        6,                                          //BYTE        StatusBusyBit
        0,                                          //BYTE        StatusErrorBit
        448,                                        //WORD        SpareDataLength
        0x70,                                       //BYTE        CmdReadStatus
        0x00,                                       //BYTE        CmdRead1
        0x30,                                       //BYTE        CmdRead2
        0x90,                                       //BYTE        CmdReadId
        0xff,                                       //BYTE        CmdReset
        0x80,                                       //BYTE        CmdWrite1
        0x10,                                       //BYTE        CmdWrite2
        0x60,                                       //BYTE        CmdErase1
        0xD0,                                       //BYTE        CmdErase2
        {20, 8, 15, 20}                             //NANDTiming  timings
    },
    //K9LBG08U1E
    {
        {NAND, 2048, 8192 * 128, 128, 8192},        //FlashInfo   fi;     
        {0xEC, 0xD7, 0xC5, 0x72},                   //BYTE        NANDCode[NANDID_LENGTH]
        3,                                          //BYTE        NumBlockCycles
        5,                                          //BYTE        ChipAddrCycleNum
        8,                                          //BYTE        DataWidth
        2,                                          //BYTE        BBMarkNum
        {0, 127},                                   //BYTE        BBMarkPage
        6,                                          //BYTE        StatusBusyBit
        0,                                          //BYTE        StatusErrorBit
        436,                                        //WORD        SpareDataLength
        0x70,                                       //BYTE        CmdReadStatus
        0x00,                                       //BYTE        CmdRead1
        0x30,                                       //BYTE        CmdRead2
        0x90,                                       //BYTE        CmdReadId
        0xff,                                       //BYTE        CmdReset
        0x80,                                       //BYTE        CmdWrite1
        0x10,                                       //BYTE        CmdWrite2
        0x60,                                       //BYTE        CmdErase1
        0xD0,                                       //BYTE        CmdErase2
        {20, 8, 15, 20}                             //NANDTiming  timings
    },


	//MT29F16G08ABABA		-> Tested
    {
        {NAND, 4096, 4096 * 128, 128, 4096},        //FlashInfo   fi;     
        {0x2C, 0x48, 0x00, 0x26},                   //BYTE        NANDCode[NANDID_LENGTH]
        3,                                          //BYTE        NumBlockCycles
        5,                                          //BYTE        ChipAddrCycleNum
        8,                                          //BYTE        DataWidth
        1,                                          //BYTE        BBMarkNum
        {0},                                        //BYTE        BBMarkPage
        6,                                          //BYTE        StatusBusyBit
        0,                                          //BYTE        StatusErrorBit
        /*
         * TODO: The actual oob size for MT29F16G08ABACA is
         * 224 bytes. Use oob 218 bytes since MX53 NFC controller
         * mentions the spare area size must be less or equal 218
         * byte if ECC is enabled
         */
		218,										//WORD        SpareDataLength
        0x70,                                       //BYTE        CmdReadStatus
        0x00,                                       //BYTE        CmdRead1
        0x30,                                       //BYTE        CmdRead2
        0x90,                                       //BYTE        CmdReadId
        0xff,                                       //BYTE        CmdReset
        0x80,                                       //BYTE        CmdWrite1
        0x10,                                       //BYTE        CmdWrite2
        0x60,                                       //BYTE        CmdErase1
        0xD0,                                       //BYTE        CmdErase2
        {5, 5, 10, 20}  /* Syncr command */			//NANDTiming  timings
    },
	//MT29F8G08ABABA		-> Tested
    {
        {NAND, 2048, 4096 * 128, 128, 4096},        //FlashInfo   fi;     
        {0x2C, 0x38, 0x00, 0x26},                   //BYTE        NANDCode[NANDID_LENGTH]
        3,                                          //BYTE        NumBlockCycles
        5,                                          //BYTE        ChipAddrCycleNum
        8,                                          //BYTE        DataWidth
        1,                                          //BYTE        BBMarkNum
        {0},                                        //BYTE        BBMarkPage
        6,                                          //BYTE        StatusBusyBit
        0,                                          //BYTE        StatusErrorBit
        /*
         * TODO: The actual oob size for MT29F16G08ABACA is
         * 224 bytes. Use oob 218 bytes since MX53 NFC controller
         * mentions the spare area size must be less or equal 218
         * byte if ECC is enabled
         */
		218,										//WORD        SpareDataLength
        0x70,                                       //BYTE        CmdReadStatus
        0x00,                                       //BYTE        CmdRead1
        0x30,                                       //BYTE        CmdRead2
        0x90,                                       //BYTE        CmdReadId
        0xff,                                       //BYTE        CmdReset
        0x80,                                       //BYTE        CmdWrite1
        0x10,                                       //BYTE        CmdWrite2
        0x60,                                       //BYTE        CmdErase1
        0xD0,                                       //BYTE        CmdErase2
        {5, 5, 10, 20}  /* Syncr command */			//NANDTiming  timings
    },
	//Micron MT29F4G08 512MB	-> Not tested	
    {
        {NAND, 2048, 2048 * 64, 64, 2048},        //FlashInfo   fi; 
        {0x2C, 0xDC, 0x80, 0x95},                   //BYTE        NANDCode[NANDID_LENGTH]
        3,                                          //BYTE        NumBlockCycles
        5,                                          //BYTE        ChipAddrCycleNum
        8,                                          //BYTE        DataWidth
        1,                                          //BYTE        BBMarkNum
        {0},                                        //BYTE        BBMarkPage
        6,                                          //BYTE        StatusBusyBit
        0,                                          //BYTE        StatusErrorBit
        64,                                         //WORD        SpareDataLength
        0x70,                                       //BYTE        CmdReadStatus
        0x00,                                       //BYTE        CmdRead1
        0x30,                                       //BYTE        CmdRead2
        0x90,                                       //BYTE        CmdReadId
        0xff,                                       //BYTE        CmdReset
        0x80,                                       //BYTE        CmdWrite1
        0x10,                                       //BYTE        CmdWrite2
        0x60,                                       //BYTE        CmdErase1
        0xD0,                                       //BYTE        CmdErase2
        {10, 5, 10, 18}                            //NANDTiming  timings
    },
	//Micron MT29F2G08 256MB	-> Tested	
    {
        {NAND, 2048, 2048 * 64, 64, 2048},        //FlashInfo   fi; 
        {0x2C, 0xDA, 0x80, 0x95},                   //BYTE        NANDCode[NANDID_LENGTH]
        3,                                          //BYTE        NumBlockCycles
        5,                                          //BYTE        ChipAddrCycleNum
        8,                                          //BYTE        DataWidth
        1,                                          //BYTE        BBMarkNum
        {0},                                        //BYTE        BBMarkPage
        6,                                          //BYTE        StatusBusyBit
        0,                                          //BYTE        StatusErrorBit
        64,                                         //WORD        SpareDataLength
        0x70,                                       //BYTE        CmdReadStatus
        0x00,                                       //BYTE        CmdRead1
        0x30,                                       //BYTE        CmdRead2
        0x90,                                       //BYTE        CmdReadId
        0xff,                                       //BYTE        CmdReset
        0x80,                                       //BYTE        CmdWrite1
        0x10,                                       //BYTE        CmdWrite2
        0x60,                                       //BYTE        CmdErase1
        0xD0,                                       //BYTE        CmdErase2
        {10, 5, 10, 18}                            //NANDTiming  timings
    },
	//Micron MT29F2G08 ABAEAWP 256MB	-> Tested	
    {
        {NAND, 2048, 2048 * 64, 64, 2048},        //FlashInfo   fi; 
        {0x2C, 0xDA, 0x90, 0x95},                   //BYTE        NANDCode[NANDID_LENGTH]
        3,                                          //BYTE        NumBlockCycles
        5,                                          //BYTE        ChipAddrCycleNum
        8,                                          //BYTE        DataWidth
        1,                                          //BYTE        BBMarkNum
        {0},                                        //BYTE        BBMarkPage
        6,                                          //BYTE        StatusBusyBit
        0,                                          //BYTE        StatusErrorBit
        64,                                         //WORD        SpareDataLength
        0x70,                                       //BYTE        CmdReadStatus
        0x00,                                       //BYTE        CmdRead1
        0x30,                                       //BYTE        CmdRead2
        0x90,                                       //BYTE        CmdReadId
        0xff,                                       //BYTE        CmdReset
        0x80,                                       //BYTE        CmdWrite1
        0x10,                                       //BYTE        CmdWrite2
        0x60,                                       //BYTE        CmdErase1
        0xD0,                                       //BYTE        CmdErase2
        {7, 5, 10, 16}                            //NANDTiming  timings
    },
    //K9LBG08U0D
    {
        {NAND, 8192, 4096 * 128, 128, 4096},        //FlashInfo   fi;     
        {0xEC, 0xD7, 0xD5, 0x29},                   //BYTE        NANDCode[NANDID_LENGTH]
        3,                                          //BYTE        NumBlockCycles
        5,                                          //BYTE        ChipAddrCycleNum
        8,                                          //BYTE        DataWidth
        1,                                          //BYTE        BBMarkNum
        {127},                                      //BYTE        BBMarkPage
        6,                                          //BYTE        StatusBusyBit
        0,                                          //BYTE        StatusErrorBit
        218,                                        //WORD        SpareDataLength
        0x70,                                       //BYTE        CmdReadStatus
        0x00,                                       //BYTE        CmdRead1
        0x30,                                       //BYTE        CmdRead2
        0x90,                                       //BYTE        CmdReadId
        0xff,                                       //BYTE        CmdReset
        0x80,                                       //BYTE        CmdWrite1
        0x10,                                       //BYTE        CmdWrite2
        0x60,                                       //BYTE        CmdErase1
        0xD0,                                       //BYTE        CmdErase2
        {20, 8, 15, 20}                             //NANDTiming  timings
    },
	// Samsung  K9F1G08U0B 128MB	-> Tested	
    {
        {NAND, 1024, 2048 * 64, 64, 2048},        //FlashInfo   fi; 
        {0xEC, 0xF1, 0x00, 0x95},                   //BYTE        NANDCode[NANDID_LENGTH]
        3,                                          //BYTE        NumBlockCycles
        4,                                          //BYTE        ChipAddrCycleNum
        8,                                          //BYTE        DataWidth
        1,                                          //BYTE        BBMarkNum
        {0},                                        //BYTE        BBMarkPage
        6,                                          //BYTE        StatusBusyBit
        0,                                          //BYTE        StatusErrorBit
        64,                                         //WORD        SpareDataLength
        0x70,                                       //BYTE        CmdReadStatus
        0x00,                                       //BYTE        CmdRead1
        0x30,                                       //BYTE        CmdRead2
        0x90,                                       //BYTE        CmdReadId
        0xff,                                       //BYTE        CmdReset
        0x80,                                       //BYTE        CmdWrite1
        0x10,                                       //BYTE        CmdWrite2
        0x60,                                       //BYTE        CmdErase1
        0xD0,                                       //BYTE        CmdErase2
        {12, 5, 12, 20}                            //NANDTiming  timings
    },
	//Micron MT29F4G08 ABADA 512MB	-> Tested	
	{
      {NAND, 4096, 2048 * 64, 64, 2048},        //FlashInfo   fi; 
      {0x2C, 0xDC, 0x90, 0x95},                   //BYTE        NANDCode[NANDID_LENGTH]
      3,                                          //BYTE        NumBlockCycles
      5,                                          //BYTE        ChipAddrCycleNum
      8,                                          //BYTE        DataWidth
      1,                                          //BYTE        BBMarkNum
      {0},                                        //BYTE        BBMarkPage
      6,                                          //BYTE        StatusBusyBit
      0,                                          //BYTE        StatusErrorBit
      64,                                         //WORD        SpareDataLength
      0x70,                                       //BYTE        CmdReadStatus
      0x00,                                       //BYTE        CmdRead1
      0x30,                                       //BYTE        CmdRead2
      0x90,                                       //BYTE        CmdReadId
      0xff,                                       //BYTE        CmdReset
      0x80,                                       //BYTE        CmdWrite1
      0x10,                                       //BYTE        CmdWrite2
      0x60,                                       //BYTE        CmdErase1
      0xD0,                                       //BYTE        CmdErase2
      {7, 5, 10, 16}                            //NANDTiming  timings
	},
	// ATO  ATO1G08U0B 128MB
    {
        {NAND, 1024, 2048 * 64, 64, 2048},        //FlashInfo   fi; 
        {0x9B, 0xF1, 0x00, 0x1D},                   //BYTE        NANDCode[NANDID_LENGTH]
        3,                                          //BYTE        NumBlockCycles
        4,                                          //BYTE        ChipAddrCycleNum
        8,                                          //BYTE        DataWidth
        1,                                          //BYTE        BBMarkNum
        {0},                                        //BYTE        BBMarkPage
        6,                                          //BYTE        StatusBusyBit
        0,                                          //BYTE        StatusErrorBit
        64,                                         //WORD        SpareDataLength
        0x70,                                       //BYTE        CmdReadStatus
        0x00,                                       //BYTE        CmdRead1
        0x30,                                       //BYTE        CmdRead2
        0x90,                                       //BYTE        CmdReadId
        0xff,                                       //BYTE        CmdReset
        0x80,                                       //BYTE        CmdWrite1
        0x10,                                       //BYTE        CmdWrite2
        0x60,                                       //BYTE        CmdErase1
        0xD0,                                       //BYTE        CmdErase2
        {12, 5, 12, 20}                            //NANDTiming  timings
    },
	//Fidelix FMND4G08U3	512MB	-> Tested	
    {
        {NAND, 4096, 2048 * 64, 64, 2048},        //FlashInfo   fi; 
        {0xAD, 0xDC, 0x90, 0x95},                   //BYTE        NANDCode[NANDID_LENGTH]
        3,                                          //BYTE        NumBlockCycles
        5,                                          //BYTE        ChipAddrCycleNum
        8,                                          //BYTE        DataWidth
        1,                                          //BYTE        BBMarkNum
        {0},                                        //BYTE        BBMarkPage
        6,                                          //BYTE        StatusBusyBit
        0,                                          //BYTE        StatusErrorBit
        64,                                         //WORD        SpareDataLength
        0x70,                                       //BYTE        CmdReadStatus
        0x00,                                       //BYTE        CmdRead1
        0x30,                                       //BYTE        CmdRead2
        0x90,                                       //BYTE        CmdReadId
        0xff,                                       //BYTE        CmdReset
        0x80,                                       //BYTE        CmdWrite1
        0x10,                                       //BYTE        CmdWrite2
        0x60,                                       //BYTE        CmdErase1
        0xD0,                                       //BYTE        CmdErase2
        {12, 5, 12, 20}                            //NANDTiming  timings
    },
	//ISSI IS34ML01G081 512MB
	{
      {NAND, 4096, 2048 * 64, 64, 2048},        //FlashInfo   fi; 
      {0xC8, 0xDC, 0x90, 0x95},                   //BYTE        NANDCode[NANDID_LENGTH]
      3,                                          //BYTE        NumBlockCycles
      5,                                          //BYTE        ChipAddrCycleNum
      8,                                          //BYTE        DataWidth
      1,                                          //BYTE        BBMarkNum
      {0},                                        //BYTE        BBMarkPage
      6,                                          //BYTE        StatusBusyBit
      0,                                          //BYTE        StatusErrorBit
      64,                                         //WORD        SpareDataLength
      0x70,                                       //BYTE        CmdReadStatus
      0x00,                                       //BYTE        CmdRead1
      0x30,                                       //BYTE        CmdRead2
      0x90,                                       //BYTE        CmdReadId
      0xff,                                       //BYTE        CmdReset
      0x80,                                       //BYTE        CmdWrite1
      0x10,                                       //BYTE        CmdWrite2
      0x60,                                       //BYTE        CmdErase1
      0xD0,                                       //BYTE        CmdErase2
      {12, 5, 12, 10}                            //NANDTiming  timings
	},
};

#endif    // __NAND_TYPES_H__

